题目链接:点击查看
题目大意:给出一个长度为 n n n 的序列,现在要求拆分成两个子序列,使得两个子序列的贡献之和最 小。对于一个序列的贡献就是,去掉相邻且相同的字母后的长度,即 ∑ i = 1 n [ a [ i ] ! = a [ i − 1 ] ] \sum_{i=1}^{n}[a[i]!=a[i-1]] ∑i=1n[a[i]!=a[i−1]],其中 a [ 0 ] = 0 a[0]=0 a[0]=0。
题目分析:本题有贪心解法,参考 CodeForces - 1480D1,只需要将规则三的 l a s t [ v 1 ] last[v1] last[v1] 和 l a s t [ v 2 ] last[v2] last[v2] 比较时的小于号换成大于号即可
贪心解法不多赘述,这里想写一下动态规划的解法
首先对原序列做一下处理,因为我们是要求最小的贡献之和,所以不难看出,如果将相邻相同的项合并,并不会影响最后的答案
所以设计一个 d p dp dp, d p [ i ] dp[i] dp[i] 为:以 a [ i ] a[i] a[i] 为序列一结尾,以 a [ i − 1 ] a[i-1] a[i−1] 为序列二结尾的最小贡献,转移方程如下:
解释一下第二个方程,其实就是在选定某个位置 i i i 和位置 j j j 后,将 [ j + 1 , i − 1 ] [j+1,i-1] [j+1,i−1] 这 ( i − 1 ) − j (i-1)-j (i−1)−j 个数都接在 a [ j ] a[j] a[j] 后面;将 a [ i ] a[i] a[i] 接在 a [ j − 1 ] a[j-1] a[j−1] 后面
上面方程转移的复杂度是 O ( n 2 ) O(n^2) O(n2) 级别的,但是不难发现,因为我们需要求最小的答案,那么令 [ a [ i ] ≠ a [ j − 1 ] ] [a[i] \neq a[j-1]] [a[i]=a[j−1]] 这一项为 0 0 0 显然是最优的,也就是让相同的两项挨起来是更优的
所以我们可以记录一下位置 i i i 前面一次出现 a [ i ] a[i] a[i] 的位置 j j j,满足 a [ i ] = a [ j ] a[i]=a[j] a[i]=a[j],这样直接用 j j j 进行转移就可以了
代码:
// Problem: D2. Painting the Array II
// Contest: Codeforces - Codeforces Round #700 (Div. 2)
// URL: https://codeforces.com/contest/1480/problem/D2
// Memory Limit: 512 MB
// Time Limit: 2000 ms
//
// Powered by CP Editor (https://cpeditor.org)
// #pragma GCC optimize(2)
// #pragma GCC optimize("Ofast","inline","-ffast-math")
// #pragma GCC target("avx,sse2,sse3,sse4,mmx")
#include<iostream>
#include<cstdio>
#include<string>
#include<ctime>
#include<cmath>
#include<cstring>
#include<algorithm>
#include<stack>
#include<climits>
#include<queue>
#include<map>
#include<set>
#include<sstream>
#include<cassert>
#include<bitset>
#define lowbit(x) x&-x
using namespace std;
typedef long long LL;
typedef unsigned long long ull;
template<typename T>
inline void read(T &x)
{
T f=1;x=0;
char ch=getchar();
while(0==isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
while(0!=isdigit(ch)) x=(x<<1)+(x<<3)+ch-'0',ch=getchar();
x*=f;
}
template<typename T>
inline void write(T x)
{
if(x<0){x=~(x-1);putchar('-');}
if(x>9)write(x/10);
putchar(x%10+'0');
}
const int inf=0x3f3f3f3f;
const int N=1e6+100;
int a[N],last[N],dp[N];
int main()
{
#ifndef ONLINE_JUDGE
// freopen("data.in.txt","r",stdin);
// freopen("data.out.txt","w",stdout);
#endif
// ios::sync_with_stdio(false);
int n,m=0;
read(n);
for(int i=1;i<=n;i++) {
read(a[i]);
if(a[i]!=a[m]) {
a[++m]=a[i];
}
}
int ans=m;
for(int i=1;i<=m;i++) {
dp[i]=dp[i-1]+1;
if(last[a[i]]) {
int j=last[a[i]]+1;
dp[i]=min(dp[i],dp[j]+i-j-1);
}
last[a[i]]=i;
ans=min(ans,dp[i]+(m-i));
}
cout<<ans<<endl;
return 0;
}